Modul 5 · 5.2
Slovenčina
Export kalendára a kontaktov z Google a Microsoft
Modul 5: Kalendár a kontakty · Čas čítania: 12 minút
Cieľ lekcie: Po tejto lekcii dokážete vytvoriť úplný a použiteľný export kalendárov a kontaktov z Google a Microsoft, prečítať súbor ICS a vCard a budete vedieť, čo sa pri exporte neprenesie alebo prenesie inak.
Kľúčové pojmy: iCalendar (ICS), VCALENDAR, VEVENT, UID, DTSTART, RRULE, EXDATE, VTIMEZONE a TZID, ORGANIZER a ATTENDEE, VALARM, vCard (VCF) 3.0 a 4.0, csv, Google Takeout, migračný nástroj
Dva formáty súborov, ktoré pozná takmer každý
Kalendáre a kontakty presúvate pomocou dvoch otvorených formátov:
- iCalendar, súbory s príponou
.ics(RFC 5545), pre kalendáre a úlohy. - vCard, súbory s príponou
.vcf, pre kontaktné osoby. Stretnete sa s dvoma verziami: 3.0 (RFC 2426) a 4.0 (RFC 6350).
Sú to obyčajné textové súbory. Môžete ich otvoriť v textovom editore, a presne to v tejto lekcii urobíte. Kto vie, čo v nich je, vidí aj to, čo v nich chýba.
Často existuje jednoduchšia cesta ako exportovanie: mnohé nové služby majú migračný nástroj, ktorý s vaším súhlasom stiahne kalendáre a kontakty priamo z Google alebo Microsoft. Je to rýchlejšie a s menším počtom chýb. Napriek tomu je vlastný export rozumný: ako kontrola (koľko som mal stretnutí a kontaktov?), ako záloha pred zrušením starej služby a ako záchranné riešenie, ak vám správca migračný nástroj nepovolí.
Ako vyzerá súbor kalendára
Export kalendára organizácie Bakkerij De Korrel začína takto:
BEGIN:VCALENDAR
VERSION:2.0
PRODID:-//Google Inc//Google Calendar 70.9054//EN
BEGIN:VTIMEZONE
TZID:Europe/Amsterdam
...
END:VTIMEZONE
BEGIN:VEVENT
UID:3f1a9c2e7b@google.com
DTSTART;TZID=Europe/Amsterdam:20261110T060000
DTEND;TZID=Europe/Amsterdam:20261110T070000
RRULE:FREQ=WEEKLY;BYDAY=TU
EXDATE;TZID=Europe/Amsterdam:20261229T060000
SUMMARY:Levering meel
ORGANIZER:mailto:anne@example.com
ATTENDEE;CN=Groothandel:mailto:verkoop@example.net
BEGIN:VALARM
TRIGGER:-PT30M
ACTION:DISPLAY
END:VALARM
END:VEVENT
END:VCALENDARČo vidíte:
| Riadok | Význam | Kde môže nastať chyba |
|---|---|---|
BEGIN:VCALENDAR a VERSION:2.0 | toto je súbor iCalendar | ak chýba, import sa odmietne |
BEGIN:VEVENT ... END:VEVENT | jedno stretnutie | chýbajúce END znečitateľní zvyšok súboru |
UID | pevný identifikátor stretnutia | bez UID nedokáže server rozpoznať duplicity |
DTSTART;TZID=... | čas začiatku v časovom pásme | pozrite časové pásma nižšie |
RRULE | pravidlo opakovania: každý utorok | neplatné pravidlo dá jedno stretnutie namiesto série |
EXDATE | výnimka: tento utorok nie | |
ORGANIZER, ATTENDEE | kto pozval a kto je pozvaný | pozrite pozvánky nižšie |
VALARM | pripomienka, 30 minút vopred | nie každá služba pripomienky preberá |
Časové pásma
Čas s TZID=Europe/Amsterdam znamená: 6 hodín ráno v Amsterdame, aj po prechode na letný čas. Súbor by preto mal obsahovať aj blok VTIMEZONE, ktorý toto časové pásmo opisuje. Exporty z Outlooku často používajú názvy Windows, ako napríklad W. Europe Standard Time. To funguje správne, pokiaľ je blok VTIMEZONE priložený. Ak chýba, nová služba háda a stretnutia sa posunú o hodinu. Čas, ktorý končí na Z (20261110T050000Z), je v UTC a vždy jednoznačný. Čas bez časového pásma a bez Z sa nazýva „plávajúci“ čas: platí v časovom pásme toho, kto sa naň pozerá.
Celodenné stretnutia sú uvedené ako dátum bez času: DTSTART;VALUE=DATE:20261224.
Pozvánky
Stretnutie, ktoré ste organizovali vy, je v súbore uvedené s vami ako ORGANIZER. Po importe sa objaví vo vašom novom kalendári, ale účastníci ho vo svojom vlastnom kalendári stále majú ako pozvánku z vašej starej adresy, s UID starej služby. Ak stretnutie neskôr upravíte, dostanú novú pozvánku. Pri opakujúcich sa stretnutiach s externými osobami môže byť vhodnejšie po prechode pozvať znova. Stretnutia, na ktoré ste boli pozvaní vy, sa prenesú ako bežné stretnutia; odpovede organizátorovi idú cez e-mail.
Export z Google
- Kalendár: v Google Kalendári, v Nastaveniach, časť Import a export, tlačidlo Export. Dostanete zip súbor s jedným súborom ics pre každý kalendár, ktorého ste vlastníkom. Kalendáre, ktoré s vami zdieľajú iní, v ňom nie sú; tie exportuje vlastník, alebo ich exportujete po jednom z nastavení daného kalendára, ak je to povolené.
- Kontakty: v Google Kontaktoch vyberiete kontakty (alebo všetky), zvolíte Export a potom formát vCard. Google ponúka aj „Google CSV“ a „Outlook CSV“; zvoľte vCard, ktorý zachová štruktúru (viacero telefónnych čísel, adries, fotografiu).
- Všetko naraz: Google Takeout (takeout.google.com) poskytuje kalendár ako ics, kontakty ako vcf (alebo csv) a Gmail ako mbox, v zip súboroch. Hodí sa ako záloha celého účtu.
Názvy ponúk sa z času na čas menia; v prípade pochybností vyhľadajte v pomocníkovi Google výraz „export kalendára“.
Export z Microsoft
- Kalendár: v klasickom Outlooku pre Windows môžete uložiť kalendár ako súbor iCalendar (Uložiť ako, s výberom obdobia a voľby „úplné podrobnosti“). Zvoľte obdobie, ktoré siaha dostatočne dozadu aj dopredu, a zvoľte úplné podrobnosti, inak exportujete iba informáciu voľný/obsadený. V Outlooku na webe môžete kalendár publikovať ako odkaz ICS a súbor cez tento odkaz stiahnuť; publikovanie potom opäť vypnite.
- Kontakty: Outlook na webe exportuje kontakty ako csv, nie ako vCard. Klasický Outlook exportuje hromadne tiež do csv; vCard je tam možné iba pre jednotlivý kontakt. Súbor csv nedokážu mnohé služby CardDAV priamo importovať. Existujú dve riešenia: použiť migračný nástroj vašej novej služby (ten kontakty stiahne priamo), alebo csv naimportovať do adresára v Thunderbirde a odtiaľ ho exportovať ako vCard.
- Zdieľané kalendáre a kalendáre miestností sú kalendáre organizácie. Tie exportuje správca, alebo ich v novej službe nastavíte znova.
Čo sa pri exporte neprenesie alebo prenesie inak
| Časť | Čo sa stane |
|---|---|
| Prílohy k stretnutiam | väčšinou sa neprenesú; iba odkaz, alebo nič |
| Farby a kategórie | niekedy ako CATEGORIES, často nie |
| Pripomienky | niekedy, v závislosti od služby |
| Odkazy na videokonferencie (Teams, Meet) | zostávajú v stretnutí ako text, ale po zrušení služby už nefungujú |
| Skupiny kontaktov alebo štítky | nie vždy; skontrolujte po importe |
| Fotografie kontaktov | prenesú sa vo vCard, ale zväčšujú súbor |
Spočítajte pred pokračovaním
Pred exportom si zapíšte, koľko máte kontaktov a, pre niekoľko kalendárov, koľko stretnutí je v pevne stanovenom období (napríklad november). Po importe spočítajte znova. Je to najrýchlejší spôsob, ako zistiť, že niečo chýba. V úlohe tejto lekcie necháte program spočítať a skontrolovať vaše súbory.
V praxi: ako to vyzerá u poskytovateľa
V rámci WebOké Nextcloud existujú dva migračné nástroje, ktoré sťahujú priamo: WebOké Import Tool pre Google (Disk, Fotky, Kalendár a Kontakty) a Migrácia údajov pre OneDrive a Microsoft 365, pomocou ktorej importujete aj kontakty a kalendáre z vášho konta Microsoft. Ak váš kalendár pochádza odinakiaľ, súbory ics a vCard importujete sami (lekcia 5.3). Nextcloud číta vCard 3.0 aj 4.0. U iných európskych služieb existujú porovnateľné importné nástroje alebo tlačidlo importu v kalendári a adresári; formáty súborov sú všade rovnaké.
Zhrnutie
- Kalendáre presúvate ako ics (iCalendar), kontakty ako vcf (vCard 3.0 alebo 4.0); sú to čitateľné textové súbory.
- Migračný nástroj, ktorý sťahuje priamo, je často jednoduchší, ale aj tak si vytvorte vlastný export ako kontrolu a zálohu.
- V súbore ics venujte pozornosť UID, RRULE a časovým pásmam s blokom VTIMEZONE; bez neho sa stretnutia posúvajú.
- Outlook na webe exportuje kontakty iba ako csv; použite migračný nástroj alebo csv prekonvertujte na vCard.
- Vopred spočítajte kontakty a stretnutia, aby ste po importe videli, či niečo chýba.
Kvíz
Úloha
Úloha A5.2: Kontrola testovacieho exportu. Exportujte kalendár (ics) a svoje kontakty (vcf). Najprv vyplňte, koľko máte kontaktov a koľko stretnutí očakávate. Potom súbory nahrajte. Program skontroluje, či sú platné, spočíta stretnutia, opakovania a kontakty, vyhľadá časové pásma bez popisu a duplicitné kontakty a porovná to s vašimi počtami. Súbory sa iba čítajú a nebudú uchovávané.
Úloha E5.2: Čo sa neprenesie? Otvorte svoj súbor ics v textovom editore. Nájdite opakujúce sa stretnutie, stretnutie s účastníkmi a stretnutie s odkazom na videokonferenciu. Pri každom stretnutí si poznačte, čo musíte po prechode urobiť.
Úloha E5.2: Čo sa neprenesie?
Otvorte svoj vlastný súbor ics v textovom editore.
Vaše zaškrtnutia a poznámky zostávajú iba v tomto prehliadači, nikam ich neposielame. Po prihlásení si v sekcii Moje kurzy uchovávame iba to, že ste úlohu splnili.
Ďalšie čítanie
Kroky v týchto článkoch platia pre služby WebOké; u iných poskytovateľov to funguje porovnateľne.
- Návod na Nextcloud 13.5: Presun kalendára a kontaktov zo služby Google, iCloud alebo Outlook (ics a vCard)
- Návod na Nextcloud 13.2: Prenos Google Drive, Fotografií, Kalendára a Kontaktov pomocou nástroja WebOké Import Tool
- Návod na Nextcloud 13.4: Presťahovanie OneDrive pomocou Migrácie dát
- Návod na Nextcloud 13.6: Z Microsoft 365 na WebOké: súbory, dokumenty, pošta a kalendár
- RFC 5545 (iCalendar), RFC 2426 (vCard 3.0), RFC 6350 (vCard 4.0)
- Pomocník Google Kalendára: Export udalostí; Pomocník Google Kontaktov: Export kontaktov; Podpora Microsoftu: Export kontaktov z Outlooku
